# Uses of Annotation Interface
net.shibboleth.shared.annotation.constraint.NullableElements

Packages that use NullableElements
Package
Description
net.shibboleth.shared.logic
Classes that represent basic first order logic concepts.
net.shibboleth.shared.net
Shared networking APIs and classes.
net.shibboleth.shared.primitive
A set of utilities dealing with Java's primitive types.
net.shibboleth.shared.resolver
Interfaces for searching over data.
net.shibboleth.shared.spring.factory
Spring factory beans.
net.shibboleth.shared.spring.velocity
Side-port of Velocity support from Spring 4 after removal from Spring 5.
net.shibboleth.shared.testing
Classes supporting testing of other classes.
net.shibboleth.shared.xml.impl
XML implementation classes.
net.shibboleth.utilities.java.support.primitive
A set of utilities dealing with Java's primitive types.

## Uses of NullableElements in net.shibboleth.shared.logic

Method parameters in net.shibboleth.shared.logic with annotations of type NullableElements
Modifier and Type
Method
Description
`static <T> Collection<T>`
Constraint.`isEmpty(Collection<T> collection, String message)`
Checks that the given collection is null or empty.
`static byte[]`
Constraint.`isNotEmpty(byte[] array, String message)`
Checks that the given byte array is not empty.
`static <T> Collection<T>`
Constraint.`isNotEmpty(Collection<T> collection, String message)`
Checks that the given collection is not empty.
`static <T> T[]`
Constraint.`isNotEmpty(T[] array, String message)`
Checks that the given array is not empty.
`static <T extends Collection<?>>
T`
Constraint.`noNullItems(T collection, String message)`
Checks that the collection is non null and does not contain any null elements.
`boolean`
AllMatchPredicate.`test(Iterable<T> inputs)`
`boolean`
AnyMatchPredicate.`test(Iterable<T> inputs)`
Constructor parameters in net.shibboleth.shared.logic with annotations of type NullableElements
Modifier
Constructor
Description
``
`StrategyIndirectedPredicate(Function<T1,T2> objectStrategy, Collection<T2> collection)`
Constructor that simplifies constructing a test for containment in a collection, which is a common use case.

## Uses of NullableElements in net.shibboleth.shared.net

Methods in net.shibboleth.shared.net with annotations of type NullableElements
Modifier and Type
Method
Description
`static Map<String,String>`
URISupport.`buildQueryMap(List<Pair<String,String>> parameters)`
Builds a map from a collection of parameters.
`static Map<String,List<String>>`
URISupport.`buildQueryMultiMap(List<Pair<String,String>> parameters)`
Builds a map from a collection of parameters.
Method parameters in net.shibboleth.shared.net with annotations of type NullableElements
Modifier and Type
Method
Description
`static Map<String,String>`
URISupport.`buildQueryMap(List<Pair<String,String>> parameters)`
Builds a map from a collection of parameters.
`static Map<String,List<String>>`
URISupport.`buildQueryMultiMap(List<Pair<String,String>> parameters)`
Builds a map from a collection of parameters.

## Uses of NullableElements in net.shibboleth.shared.primitive

Method parameters in net.shibboleth.shared.primitive with annotations of type NullableElements
Modifier and Type
Method
Description
`static <T> T`
ObjectSupport.`firstNonNull(T... objects)`
Return the first from a list of arguments that is non-null, or null if all arguments are null.
`static Collection<String>`
StringSupport.`normalizeStringCollection(Collection<String> values)`
Normalize a string collection by: Safely trimming each member. Converting all empty members to null. Removing any null members.

## Uses of NullableElements in net.shibboleth.shared.resolver

Constructor parameters in net.shibboleth.shared.resolver with annotations of type NullableElements
Modifier
Constructor
Description
``
`CriteriaSet(Criterion... criteria)`
A convenience constructor for constructing and adding criteria.

## Uses of NullableElements in net.shibboleth.shared.spring.factory

Methods in net.shibboleth.shared.spring.factory with annotations of type NullableElements
Modifier and Type
Method
Description
`protected List<Object>`
CombiningListFactoryBean.`createInstance()`
`List<?>`
CombiningListFactoryBean.`getFirstList()`
Set the first list to combine.
`List<?>`
CombiningListFactoryBean.`getSecondList()`
Set the second list to combine.
Method parameters in net.shibboleth.shared.spring.factory with annotations of type NullableElements
Modifier and Type
Method
Description
`void`
CombiningListFactoryBean.`setFirstList(List<?> list)`
Get the first list to combine.
`void`
CombiningListFactoryBean.`setSecondList(List<?> list)`
Get the second list to combine.

## Uses of NullableElements in net.shibboleth.shared.spring.velocity

Fields in net.shibboleth.shared.spring.velocity with annotations of type NullableElements
Modifier and Type
Field
Description
`private final Map<String,Object>`
VelocityEngineFactory.`velocityProperties`
Configuration properties.
Method parameters in net.shibboleth.shared.spring.velocity with annotations of type NullableElements
Modifier and Type
Method
Description
`protected org.apache.velocity.context.Context`
VelocityView.`createVelocityContext(Map<String,Object> model)`
Create a Velocity Context instance for the given model, to be passed to the template for merging.
`protected org.apache.velocity.context.Context`
VelocityView.`createVelocityContext(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)`
Create a Velocity Context instance for the given model, to be passed to the template for merging.
`protected void`
VelocityView.`renderMergedTemplateModel(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)`
Process the model map by merging it with the Velocity template.
`void`
VelocityEngineFactory.`setVelocityPropertiesMap(Map<String,Object> map)`
Set Velocity properties as Map, to allow for non-String values like "ds.resource.loader.instance".

## Uses of NullableElements in net.shibboleth.shared.testing

Method parameters in net.shibboleth.shared.testing with annotations of type NullableElements
Modifier and Type
Method
Description
`static org.apache.velocity.app.VelocityEngine`
VelocityEngine.`newVelocityEngine(Properties props)`
Creates a new velocity engine with the supplied properties.

## Uses of NullableElements in net.shibboleth.shared.xml.impl

Methods in net.shibboleth.shared.xml.impl with annotations of type NullableElements
Modifier and Type
Method
Description
`Map<String,Object>`
BasicParserPool.`getBuilderAttributes()`
Gets the builder attributes used when creating builders.
`Map<String,Boolean>`
BasicParserPool.`getBuilderFeatures()`
Gets the builders' features.
Method parameters in net.shibboleth.shared.xml.impl with annotations of type NullableElements
Modifier and Type
Method
Description
`void`
BasicParserPool.`setBuilderAttributes(Map<String,Object> newAttributes)`
Sets the builder attributes used when creating builders.
`void`
BasicParserPool.`setBuilderFeatures(Map<String,Boolean> newFeatures)`
Sets the the builders' features.

## Uses of NullableElements in net.shibboleth.utilities.java.support.primitive

Method parameters in net.shibboleth.utilities.java.support.primitive with annotations of type NullableElements
Modifier and Type
Method
Description
`static Collection<String>`
StringSupport.`normalizeStringCollection(Collection<String> values)`
Deprecated, for removal: This API element is subject to removal in a future version.
Normalize a string collection by: Safely trimming each member. Converting all empty members to null. Removing any null members.